{$IFDEF VIRTUALPASCAL}
 {$B-,D+,H-,I-,J+,P-,Q-,R-,T-,V+,W-,X+,Z-}
 {&AlignCode+,AlignData+,AlignRec-,Asm-,Cdecl-,Delphi+,Frame+,G3+,LocInfo+}
 {&Open32-,Optimise+,OrgName-,SmartLink+,Speed+,Use32-,ZD-}
 {$M 32768}
{$ELSE}
 {$A-,B-,D+,E-,F+,G-,I-,L+,N-,O-,P-,Q-,R-,S-,T-,V-,X+,Y+}
 {$M 16384,0,655360}
{$ENDIF}
uses
     Dos,
     Wizard,

     Drivers,
     Objects;

const
 Version        = '1.0';

var
 SourceMask, DestinationMask, Ext, TempExt: String;
 Source, Destination: PStream;
 Date: Longint;
 SR: SearchRec;
 Ok: Boolean;
begin
 PrintStr(Concat('NodeListCopy, v', Version, ', (q) by sk // [rAN], 1999.', #13#10, #13#10));

 if ParamCount < 2 then
  begin
   PrintStr('syntax: nodecopy f:\fileecho\813\ranodeli.st\ran81net f:\fido\nodelist');

   Halt(255);
  end;

 SourceMask:=ParamStr(1);
 DestinationMask:=ParamStr(2);

 if SourceMask[Byte(SourceMask[0])] in ['\', '.', ':'] then
  begin
   PrintStr('syntax error');

   Halt(254);
  end;

 SourceMask:=Concat(SourceMask, '.');

 DestinationMask:=AddBackSlash(DestinationMask);

 PrintStr(Concat(SourceMask, '*', #13#10));

 FindFirst(Concat(SourceMask, '*'), AnyFile, SR);

 Date:=0;
 TempExt:='';

 while DosError = 0 do
  begin
   if SR.Attr and (Directory or VolumeID) = 0 then
    begin
     TempExt:=JustExtension(SR.Name);

     if Str2Number(TempExt) and (GetStamp(Concat(SourceMask, TempExt)) > Date) then
      begin
       Date:=GetStamp(Concat(SourceMask, TempExt));

       Ext:=TempExt;
      end;
    end;

   FindNext(SR);
  end;

 FindClose(SR);

 if Ext = '' then
  begin
   PrintStr(Concat('no any matching files found', #13#10));

   Halt(253);
  end;

 PrintStr(Concat(SourceMask, Ext, #13#10));

 DestinationMask:=Concat(DestinationMask, JustFileNameOnly(SourceMask), '.', Ext);

 PrintStr(Concat(DestinationMask, #13#10));

 Source:=New(PBufStream, Init(Concat(SourceMask, Ext), stOpenRead, 2048));

 Destination:=New(PBufStream, Init(DestinationMask, stCreate, 2048));

 Ok:=False;

 if Source^.Status <> stOk then
  PrintStr(Concat('unable to open "', SourceMask, Ext, '"', #13#10))
 else
  if Destination^.Status <> stOk then
   PrintStr(Concat('unable to create "', DestinationMask, '"', #13#10))
  else
   begin
    Ok:=True;

    Destination^.CopyFrom(Source^, Source^.GetSize);
   end;

 Dispose(Destination, Done);

 Dispose(Source, Done);

 if Ok then
  begin
   SetStamp(DestinationMask, GetStamp(Concat(SourceMask, Ext)));

   PrintStr(Concat('done', #13#10));

   Halt(0);
  end
 else
  begin
   PrintStr(Concat('failed', #13#10));

   Halt(1);
  end;
end.
